<template>
  <v-dialog
      v-model="dialog"
      width="500"
    >
    <template v-slot:activator="{ on, attrs }">
      <v-btn
        color="red lighten-2"
        dark
        v-bind="attrs"
        v-on="on"
      >
        Delegate
      </v-btn>
    </template>

    <v-card
      class="mx-auto my-12"
      max-width="400"
      >
      <v-card-title>Delegate</v-card-title>
       <v-card-text>
         <v-row
           align="center"
           justify="space-around"
         >
           <v-btn @click="delegateToSelf" color="primary">
             Delegate to self
           </v-btn>
         </v-row>
       </v-card-text>
    </v-card>
  </v-dialog>
</template>

<script>
  import GovernorVotes from "@openzeppelin/contracts/build/contracts/GovernorVotes.json";
  import ERC20Votes from "@openzeppelin/contracts/build/contracts/ERC20Votes.json";
  import { ethers } from "ethers";

  export default {
    name: "Delegator",
    methods: {
      async delegateToSelf() {
        const provider = this.$store.state.provider;

        const governor = new ethers.Contract(
          this.$store.state.governor.address,
          GovernorVotes.abi,
          provider);

        const tokenAddress = await governor.token();

        const token = new ethers.Contract(
          tokenAddress,
          ERC20Votes.abi,
          provider);

        await token.connect(provider.getSigner(this.$store.state.accounts[0])).delegate(this.$store.state.accounts[0]);
      }
    }
  }
</script>
